<script lang="ts" setup>
import AppContainer from "@/components/AppContainer.vue";
import PageHeader from "@/components/PageHeader.vue";
import UnitCard from "@/components/UnitCard.vue";
import { usersGetUsers } from "@/scripts/api-helper";
import { computed } from "vue";
import { useRoute, useRouter } from "vue-router";

import { reactive } from "vue";
import { useQuery } from "vue-query";

const router = useRouter();
const route = useRoute();
const isParentRoute = !route.params.uid;

const state = reactive({
  search: "",
  panels: [] as string[],
});

const {
  isLoading,
  isError,
  data: usersData,
} = useQuery("get-all-users", async () => {
  const res = await usersGetUsers({});
  if (!res.ok) {
    throw new Error("Failed to get users");
  }
  return res.data;
});

const filteredUsers = computed(() => {
  if (!usersData.value) return [];
  if (!state.search) return usersData.value;
  const s = state.search.toLowerCase();
  return usersData.value.filter((u) => {
    const term = u.display_name.toLowerCase() + u.sciper?.toString();
    return term.includes(s);
  });
});
</script>

<template>
  <AppContainer>
    <template v-slot:header>
      <PageHeader
        description="Cet annuaire permet de consulter la liste des membres de l'AGEPoly qui ont enregistré un compte Whiskey."
        title="Annuaire de l'AGEPoly"
      />
    </template>
    <div
      v-if="isParentRoute"
      class="flex flex-col items-center flex-grow w-full"
    >
      <div v-if="isLoading">
        <v-progress-circular
          :size="74"
          :width="11"
          indeterminate
        ></v-progress-circular>
      </div>

      <div v-else-if="isError">
        <h1>Une erreur est survenue</h1>
      </div>

      <div v-else class="flex flex-col justify-center w-full max-w-2xl">
        <v-text-field
          v-model="state.search"
          append-inner-icon="mdi-magnify"
          class="w-full mb-3"
          hide-details
          label="Rechercher une personne"
          variant="solo"
        ></v-text-field>
      </div>

      <div class="w-full">
        <div v-for="u of filteredUsers" v-bind:key="u.uid">
          <v-card @click="router.push(`/users/${u.uid}`)">
            <v-card-item>
              <h2 class="text-2xl">{{ u.display_name }}</h2>
              <p class="text-lg">{{ u.sciper ?? "Pas de SCIPER" }}</p>
            </v-card-item>
          </v-card>
        </div>
      </div>
    </div>
    <router-view></router-view>
  </AppContainer>
</template>

<style></style>
